<template>
	<div class="grid w-full">
		<form autocomplete="off">
			<div class="grid-cols-1 gap-4 grid w-full mt-2">
				<MkInput
					v-if="businessAddress"
					:id="id + 'company_name'"
					:value="addressData['companyName']"
					class="mb-4"
					variant="outline"
					label="Company name (optional)"
					@input="updateForm('companyName', $event)"
				/>
			</div>
			<div class="grid-cols-1 md:gap-6 gap-0 md:grid-cols-2 grid w-full mt-2">
				<MkInput
					:id="id + 'first_name'"
					:value="addressData['firstName']"
					:set-focus="setFocus"
					class="mb-4"
					variant="outline"
					label="First name"
					rules="required|alpha_spaces"
					@input="updateForm('firstName', $event)"
				/>
				<MkInput
					:id="id + 'last_name'"
					:value="addressData['lastName']"
					class="mb-4"
					variant="outline"
					label="Last name"
					rules="required|alpha_spaces"
					@input="updateForm('lastName', $event)"
				/>
			</div>
			<div>
				<MkGoogleAddress
					:id="id + 'address_1'"
					:country="currentRegion"
					label="Address 1"
					placeholder=" "
					:value="addressData['streetAddress1']"
					rules="required"
					variant="outline"
					class="mb-4"
					@AC_PLACE_CHANGED="fillInUserAddress"
					@change="updateForm('streetAddress1', $event)"
				/>
				<MkInput
					:id="id + 'address_2'"
					class="mb-4"
					variant="outline"
					:value="addressData['streetAddress2']"
					label="Address 2 (optional)"
					@input="updateForm('streetAddress2', $event)"
				/>
				<MkInput
					:id="id + 'city'"
					class="mb-4"
					variant="outline"
					:value="addressData['city']"
					:label="isEurope ? 'Town/City' : 'City'"
					rules="required"
					@input="updateForm('city', $event)"
				/>
			</div>
			<div v-if="!isEurope" class="grid-cols-1 md:gap-6 gap-0 md:grid-cols-2 grid w-full mt-2">
				<MkSelectDropdown
					:id="id + 'state'"
					:value="addressData['state']"
					:options="state_code_list"
					variant="outline"
					label="State"
					rules="required"
					@change="updateForm('state', $event)"
				/>
				<MkInput
					:id="id + 'postal_code'"
					:value="addressData['postalCode']"
					variant="outline"
					label="Postal Code"
					rules="required|postal_code"
					:maxlength="10"
					@input="updateForm('postalCode', $event)"
				/>
				<MkSelectDropdown
					:id="id + 'country'"
					:value="addressData['country']"
					:options="country_code_list"
					variant="outline"
					label="Country"
					rules="required"
					@change="updateForm('country', $event)"
				/>
				<MkInput
					:id="id + 'phone_number'"
					class="mb-4"
					:value="addressData['phoneNumber']"
					variant="outline"
					type="phoneNumber"
					label="Phone number"
					maxlength="14"
					rules="required|phone"
					@input="updateForm('phoneNumber', $event)"
				/>
			</div>
			<div v-if="isEurope" class="grid-cols-1 md:gap-6 gap-0 md:grid-cols-2 grid w-full mt-2">
				<MkSelectDropdown
					:id="id + 'country'"
					:value="addressData['country']"
					:options="country_code_list"
					variant="outline"
					label="Country/Region"
					rules="required"
					@change="updateForm('country', $event)"
				/>
				<MkInput
					:id="id + 'postal_code'"
					:value="addressData['postalCode']"
					class="mb-4"
					variant="outline"
					label="Postal Code"
					rules="required|postal_code"
					:maxlength="10"
					@input="updateForm('postalCode', $event)"
				/>
			</div>
			<MkInput
				v-if="isEurope"
				:id="id + 'phone_number'"
				class="mb-4"
				:value="addressData['phoneNumber']"
				variant="outline"
				type="phoneNumber"
				label="Phone number"
				maxlength="12"
				rules="required|phone"
				@input="updateForm('phoneNumber', $event)"
			/>
		</form>
	</div>
</template>
<script>
import StateList from '@/components/json/state_list.json';
import { mapState } from 'vuex';
import MkInput from '~/components/D2C/atoms/MkInput.vue';
import MkSelectDropdown from '~/components/D2C/atoms/MkSelectDropdown.vue';
import MkGoogleAddress from '~/components/D2C/atoms/MkGoogleAddress.vue';
export default {
	name: 'MkAddressForm',
	components: {
		MkSelectDropdown,
		MkInput,
		MkGoogleAddress,
	},
	props: {
		addressData: {
			type: Object,
			default() {
				return {};
			},
		},
		businessAddress: {
			type: Boolean,
			default: false,
		},
		id: {
			type: String,
			default: '',
		},
		setFocus: {
			type: String,
			default: 'false',
		},
	},
	data() {
		return {
			country_code_list: [
				{
					text: 'Canada',
					value: 'CA',
				},
				{
					text: 'United States',
					value: 'US',
				},
			],
			europeanCountries: [
				{
					text: 'Austria',
					value: 'AT',
				},
				{
					text: 'Belgium',
					value: 'BE',
				},
				{
					text: 'Bulgaria',
					value: 'BG',
				},
				{
					text: 'Croatia',
					value: 'HR',
				},
				{
					text: 'Cyprus',
					value: 'CY',
				},
				{
					text: 'Czech Republic',
					value: 'CZ',
				},
				{
					text: 'Denmark',
					value: 'DK',
				},
				{
					text: 'Estonia',
					value: 'EE',
				},
				{
					text: 'Finland',
					value: 'FI',
				},
				{
					text: 'France',
					value: 'FR',
				},
				{
					text: 'Germany',
					value: 'DE',
				},
				{
					text: 'Greece',
					value: 'GR',
				},
				{
					text: 'Hungary',
					value: 'HU',
				},
				{
					text: 'Ireland',
					value: 'IE',
				},
				{
					text: 'Italy',
					value: 'IT',
				},
				{
					text: 'Latvia',
					value: 'LV',
				},
				{
					text: 'Lithuania',
					value: 'LT',
				},
				{
					text: 'Luxembourg',
					value: 'LU',
				},
				{
					text: 'Malta',
					value: 'MT',
				},
				{
					text: 'Netherlands',
					value: 'NL',
				},
				{
					text: 'Norway',
					value: 'NO',
				},
				{
					text: 'Poland',
					value: 'PL',
				},
				{
					text: 'Portugal',
					value: 'PT',
				},
				{
					text: 'Romania',
					value: 'RO',
				},
				{
					text: 'Slovakia',
					value: 'SK',
				},
				{
					text: 'Slovenia',
					value: 'SI',
				},
				{
					text: 'Spain',
					value: 'ES',
				},
				{
					text: 'Sweden',
					value: 'SE',
				},
				{
					text: 'Switzerland',
					value: 'CH',
				},
				{
					text: 'United Kingdom',
					value: 'GB',
				},
			],
			state_code_list: StateList.US,
			currentRegion: this.$store.state.apiCountry || 'US',
		};
	},
	computed: {
		...mapState(['isEurope']),
		getCountry() {
			this.currentRegion = this.$store.state.apiCountry || 'US';
			return this.$store.state.apiCountry || 'US';
		},
	},
	mounted() {
		this.currentRegion = this.$store.state.apiCountry || 'US';
		this.state_code_list = StateList[this.currentRegion] || 'US';
		this.addressData.country = this.currentRegion; // eslint-disable-line
		if (this.isEurope) {
			this.country_code_list = this.europeanCountries;
		}
	},
	methods: {
		updateForm(fieldName, value) {
			if (fieldName === 'country') {
				this.state_code_list = StateList[value];
				this.currentRegion = value
			}
			this.$set(this.addressData, fieldName, value);
			this.$emit('input', this.addressData);
		},
		fillInUserAddress(addressData) {
			// const pfx = this.prefix
			const a = 'streetAddress1';
			const c = 'city';
			const s = 'state';
			const p = 'postalCode';
			const n = 'country';
			const {
				street_number = '', // eslint-disable-line
				route = '',
				postal_code = '', // eslint-disable-line
				administrative_area_level_1 = '', // eslint-disable-line
				locality = '',
				country = '',
				postal_town = '', // eslint-disable-line
			} = addressData;
			// eslint-disable-next-line
			const new_address_object = {
				[a]: `${street_number}` ? `${street_number} ${route}` : `${route}`, // eslint-disable-line
				[c]: locality || postal_town || ' ', // eslint-disable-line
				[s]: administrative_area_level_1 || ' ', // eslint-disable-line
				[p]: postal_code || '', // eslint-disable-line
				[n]: country || ' ',
			};
			// @@NOTE : remove all empty strings
			// eslint-disable-next-line
			if (this.isEurope) {
				delete new_address_object[s];
			}
			// eslint-disable-next-line
			for (const propName in new_address_object) {
				if (
					!new_address_object[propName].length ||
					new_address_object[propName] === null ||
					new_address_object[propName] === undefined
				) {
					delete new_address_object[propName];
				}
			}
			// @@NOTE : Update address object
			// eslint-disable-next-line
			for (const key in new_address_object) {
				this.$set(this.addressData, key, new_address_object[key]);
				this.$emit('input', this.addressData);
			}
			this.$forceUpdate();
		},
	},
};
</script>
